"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeDeep = exports.createPaginationAsyncOptions = void 0;
const pagination_constants_1 = require("../pagination.constants");
const createPaginationAsyncOptions = (options) => ({
    provide: pagination_constants_1.PAGINATION_MODULE_OPTIONS,
    useExisting: options.useExisting,
    useFactory: options.useFactory,
    useClass: options.useClass,
    inject: options.inject,
});
exports.createPaginationAsyncOptions = createPaginationAsyncOptions;
function mergeDeep(target, ...sources) {
    if (!sources.length)
        return target;
    const source = sources.shift();
    if (isObject(target) && isObject(source)) {
        for (const key in source) {
            if (isObject(source[key])) {
                if (!target[key]) {
                    target[key] = {};
                }
                mergeDeep(target[key], source[key]);
            }
            else if (source[key] !== undefined && source[key] !== null) {
                target[key] = source[key];
            }
        }
    }
    return mergeDeep(target, ...sources);
}
exports.mergeDeep = mergeDeep;
function isObject(item) {
    return item && typeof item === 'object' && !Array.isArray(item);
}
